<?php


require_once $CFG->libdir . '/formslib.php';
// describe the form created for admin_emial.php
class admin_email_form extends moodleform {

    function definition() {

        $mform =& $this->_form;

        $mform->addElement('text', 'subject', get_string('subject', 'block_bclnemail'));
        $mform->setType('subject', PARAM_TEXT);
        
        $mform->addElement('text', 'noreply', get_string('noreply', 'block_bclnemail'));
        $mform->setType('noreply', PARAM_EMAIL);

        $mform->addElement('editor', 'message_editor',  get_string('body', 'block_bclnemail'), null, $this->_customdata['editor_options']);
        $mform->setType('message', PARAM_RAW);

        $buttons = array(
            $mform->createElement('submit', 'send', get_string('send_email', 'block_bclnemail')),
            $mform->createElement('cancel', 'cancel', get_string('cancel'))
        );
        $mform->addGroup($buttons, 'actions', '&nbsp;', array(' '), false);

        $mform->addRule('subject', null, 'required', 'client');
        $mform->addRule('noreply', null, 'required', 'client');
        $mform->addRule('message_editor', null, 'required');
    }

    function validation($data, $files) {
        $errors = array();
        foreach(array('subject', 'message_editor') as $field) {
            if(empty($data[$field]))
                $errors[$field] = get_string('email_error_field', 'block_bclnemail', $field);
        }
        return $errors;
    }
}
